// 2018 - Gord Payne
// JOKE-O-LANTERN!!
// for TLLP Jack-o-lantern contest
//
// pins
// A4 - LCD SDA
// A5 - LCD SCL
// 3 - button
// 6 - speaker
// 8 - servo for Smartie dispenser
// 
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include "pitches.h"
#define NO_SOUND 0 // makes the rests in music
#include <TimerFreeTone.h>
// Set the LCD address to 0x27 for a 16 chars and 2 line display. May be 0x3F. Use i2cScanner sketch to find address if needed.
LiquidCrystal_I2C lcd(0x3F, 16, 4);
#include <Servo.h>

Servo myservo;  // create servo object to control a servo
int pos;   // variable to store the servo position
long distCount = 1; // for repeated distance sampling to eliminate false dispenses
long distAvg = 0;

int trigR = 11; // SR-04 pins for send/receive pings
int  echoR = 12;
long lastD = millis(); // for dispensing no more frequently than once every 5 seconds
long dThresh = 5000;
boolean dispense = true;
long durationR, distanceR;
int btn = 3;// Light dependent resistor
int btVal;
int spkr = 6;
long thresh = 250;// light threshold at reset
long lastPress = millis();
// Chopin arrays
int melody[] = {

  NOTE_A3, NOTE_A3, NOTE_A3, NOTE_A3, NOTE_C4, NOTE_B3, NOTE_B3, NOTE_A3, NOTE_A3, NOTE_GS3, NOTE_A3
};


// note durations: 4 = quarter note, 8 = eighth note, etc.:
int noteDurations[] = {
  // 2, 2, 4, 2, 2, 4, 2, 4,2,4,1
  2, 2, 4, 2, 2, 4, 2, 4, 2, 4, 1
};

// Thriller arrays

int melodyT[] = {
  NOTE_GS4, NOTE_B4, NOTE_GS4, NOTE_CS5, NOTE_B4, NOTE_B4, NOTE_AS4, NOTE_GS4
};

// note duration 1 = whole note, 2 = half note, 4 = quarter note, 8 = 8th note etc.

int noteDurationsT[] = {
  8, 7, 8, 4, 2, 4, 4, 2
};

int pace = 1450;






// declare array of strings as pointer to chars array
// holds the messages
char* msg[] = {
  "Q: What do ghosts",
  " eat for supper?",
  "",
  "",
  "",
  "  A: Spooketti",
  "",
  "",
  " Q: What do you do",
  "  when 50 zombies",
  "surround your house?",
  "",
  "",
  "   A: Hope it\u0027s",
  "     Halloween!!",
  "",
  "Q: What is the most",
  "important subject a",
  "  witch learns in",
  "      school?",
  "",
  "   A: Spelling.",
  "",
  "",
  "Q: Why didn\u0027t the",
  " skeleton want to",
  " go to school?",
  "",
  "",
  "   A: His heart ",
  "    wasn\u0027t in it.",
  "",
  "Q: Why didn\u0027t the",
  "skeleton cross the",
  "      road?",
  "",
  "",
  "A: He didn\u0027t have",
  "    any guts!",
  "",
  "Q: What room does a",
  "  ghost not need?",
  "",
  "",
  "",
  " A: A living room!",
  "",
  "",
  "  Q: Who did",
  "Frankenstein take",
  "  to the dance?",
  "",
  "",
  "    A: His",
  "   \u0027ghoul\u0027 friend!",
  "",
  "  Q: What do ghosts",
  "     use to wash",
  "     their hair?",
  "",
  "",
  "  A: ShamBOOOO!!",
  "",
  "",
  "Q: What\u0027s a ",
  " vampire\u0027s",
  "  favourite fruit?",
  "",
  "",
  "A: A neck-tarine!",
  "",
  "",
  "",
  "Q: What dessert does",
  "   a ghost like?",
  "",
  "",
  "    A: I SCREAM!!",
  "",
  "",
  "",
  "Q: What do birds say",
  "   on Halloween?",
  "",
  "",
  "A: Twick o tweet!",
  "",
  "",
  "",
  "Q: Where do ghosts",
  " buy their food?",
  "",
  "",
  "   A: At the",
  " ghost-ery store!"
  ""
};

void setup() {
  //myservo.attach(8);
  // delay(500);
  // myservo.write(0);
  // delay(500);
  // myservo.detach();
  // put your setup code here, to run once:
  pinMode(btn, INPUT_PULLUP); // use Analog 0 as an input for LDR
  pinMode(spkr, OUTPUT);
  pinMode(trigR, OUTPUT);
  pinMode(echoR, INPUT);
  Serial.begin(9600);

  lcd.begin();

  // Turn on the blacklight and print a message.
  lcd.backlight();


  randomSeed(analogRead(A1));// get a random seed for joke generator
  swipeMsg(); // default screen message

}

void loop() {
  digitalWrite(trigR, LOW); // sample distance
  delayMicroseconds(2);
  digitalWrite(trigR, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigR, LOW);
  durationR = pulseIn(echoR, HIGH);
  distanceR = durationR / 58; // convert to centimetres
  //Serial.println(distanceR);
  if (distCount <= 25) { // if we not yet at 25 samples
    distAvg = distAvg + distanceR;
    distCount ++;
  }
  else {// if at 25 samples
    distAvg = distAvg / 25;  // calculate average measured distance and restart average

    distAvg = 0;
    distCount = 1;
  }

  if ((distAvg !=0)&&(distAvg < 6) && (millis() - lastD > dThresh) && (dispense == true)) {
    // Serial.println("dispense");
    dispenseSmartie();
    lastD = millis(); // restart timer
  }
  btVal = digitalRead(btn); // scan button
  if ((btVal == LOW) && (millis() - lastPress > thresh)) {
    //Serial.println("btn");
    lcd.clear();
    dispense = false; // don't allow candy to dispense
    randMsg();// generate a random message and display it
    lastPress = millis(); // reset button timer
    // swipeMsg();
    delay(20);
  }
}



void randMsg() {
  int msgNum = (int) random(12);// random integer between 0 and 11
  showMsg(msgNum); // scroll the selected message across the screen
}

void showMsg(int msgNum) {
// show the selected joke
  int msgOffset = msgNum * 8;
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print(msg[msgOffset]);
  lcd.setCursor(0, 1);
  lcd.print(msg[msgOffset + 1]);
  lcd.setCursor(0, 2);
  lcd.print(msg[msgOffset + 2]);
  lcd.setCursor(0, 3);
  lcd.print(msg[msgOffset + 3]);
  for (int i = 500; i < 1200; i++) { // play up sweep sounds
    TimerFreeTone(spkr, i, 1);
  }
  TimerFreeTone(spkr, 0, 0);
  delay(3000);
  lcd.clear();
  // display joke answer
  lcd.setCursor(0, 0);
  lcd.print(msg[msgOffset + 4]);
  lcd.setCursor(0, 1);
  lcd.print(msg[msgOffset + 5]);
  lcd.setCursor(0, 2);
  lcd.print(msg[msgOffset + 6]);
  lcd.setCursor(0, 3);
  lcd.print(msg[msgOffset + 7]);
  delay(1000);
  playChopin();

  lcd.clear();
  swipeMsg(); // return to default screen
  dispense = true;
}

void swipeMsg() { // default screen message
  lcd.clear();
  lcd.setCursor(2, 0);
  lcd.print(" Btn for Trick!");

  lcd.setCursor(0, 2);
  lcd.print("  Palm Under Mouth");
  lcd.setCursor(5, 3);
  lcd.print("for Treat!");
  
}

void playChopin() {
  for (int thisNote = 0; thisNote < 11; thisNote++) {

    // to calculate the note duration, take one second divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 450 / noteDurations[thisNote];// was 1000
    TimerFreeTone(spkr, melody[thisNote], noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration ;// was 1.10;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    TimerFreeTone(spkr, 0, 0);
  }
}

void playThriller() {
  for (int thisNote = 0; thisNote < 8; thisNote++) {

    // to calculate the note duration, take one second divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000 / noteDurationsT[thisNote];
    TimerFreeTone(spkr, melodyT[thisNote], noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.10;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    TimerFreeTone(spkr, 0, 0);
  }
}

void dispenseSmartie() {
  lcd.clear();
  lcd.setCursor(2, 1);
  lcd.print("Here's Your Treat!");
  myservo.attach(8);// attach servo

  myservo.write(0);// reset position

// do servo sweep for dispensing Smartie
  for (pos = 0; pos <= 50; pos += 1) { // goes from 0 degrees to 180 degrees
    // in steps of 1 degree
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
    delay(15);                       // waits 15ms for the servo to reach the position
  }
  delay(150);
  for (pos = 50; pos >= 0; pos -= 1) { // goes from 180 degrees to 0 degrees
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
    delay(15);                       // waits 15ms for the servo to reach the position
  }

  myservo.detach(); //detach servo when not needed

  playThriller();
  swipeMsg(); // return to default screen message
}
